// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    EgfaModuleExperimentierklauselEntityDTO,
    EgfaModuleExperimentierklauselEntityResponseDTO,
} from '../models';

export interface GetEgfaModule7Request {
    egfaId: string;
}

export interface ModifyEgfaModule7Request {
    egfaId: string;
    egfaModuleExperimentierklauselEntityDTO: EgfaModuleExperimentierklauselEntityDTO;
}

/**
 * no description
 */
export class EgfaModuleExperimentierklauselControllerApi extends BaseAPI {

    /**
     * Lädt ein Experimentierklausel Modul
     * GET Experimentierklausel MODUL
     */
    getEgfaModule7({ egfaId }: GetEgfaModule7Request): Observable<EgfaModuleExperimentierklauselEntityResponseDTO>
    getEgfaModule7({ egfaId }: GetEgfaModule7Request, opts?: OperationOpts): Observable<AjaxResponse<EgfaModuleExperimentierklauselEntityResponseDTO>>
    getEgfaModule7({ egfaId }: GetEgfaModule7Request, opts?: OperationOpts): Observable<EgfaModuleExperimentierklauselEntityResponseDTO | AjaxResponse<EgfaModuleExperimentierklauselEntityResponseDTO>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'getEgfaModule7');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaModuleExperimentierklauselEntityResponseDTO>({
            url: '/egfamodules/experimentierklausel/{egfaId}'.replace('{egfaId}', encodeURI(egfaId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert den Experimentierklausel Modul
     * PUT Experimentierklausel MODUL
     */
    modifyEgfaModule7({ egfaId, egfaModuleExperimentierklauselEntityDTO }: ModifyEgfaModule7Request): Observable<EgfaModuleExperimentierklauselEntityResponseDTO>
    modifyEgfaModule7({ egfaId, egfaModuleExperimentierklauselEntityDTO }: ModifyEgfaModule7Request, opts?: OperationOpts): Observable<AjaxResponse<EgfaModuleExperimentierklauselEntityResponseDTO>>
    modifyEgfaModule7({ egfaId, egfaModuleExperimentierklauselEntityDTO }: ModifyEgfaModule7Request, opts?: OperationOpts): Observable<EgfaModuleExperimentierklauselEntityResponseDTO | AjaxResponse<EgfaModuleExperimentierklauselEntityResponseDTO>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'modifyEgfaModule7');
        throwIfNullOrUndefined(egfaModuleExperimentierklauselEntityDTO, 'egfaModuleExperimentierklauselEntityDTO', 'modifyEgfaModule7');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaModuleExperimentierklauselEntityResponseDTO>({
            url: '/egfamodules/experimentierklausel/{egfaId}'.replace('{egfaId}', encodeURI(egfaId)),
            method: 'PUT',
            headers,
            body: egfaModuleExperimentierklauselEntityDTO,
        }, opts?.responseOpts);
    };

}
